* pcxLib.PRG                                                                *
* Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved.  *

*****************************************************************************
*                                                                           *
* Function declarations for the PCX Programmer's Toolkit, for Clipper.      *
*                                                                           *
*                                                                           *
*                                                                           *
* Clipper Summer '87                      Programmer: Chris Howard  5/23/88 *
*                                                                           *
*****************************************************************************

PROCEDURE pcxInit                           && Init PCX Clipper constants

* PCX Version number
PUBLIC               pcxhard
pcxhard              = 5                    && Version = 3.0 w/palette

* PCX Display modes
PUBLIC               pcxTEXT,pcxGRAPHICS
pcxTEXT              = 0                    && Text mode
pcxGRAPHICS          = 1                    && Graphics mode

* PCX Display types
PUBLIC               pcxCGA_4, pcxCGA_6, pcxEGA_D, pcxEGA_E, pcxEGA_F
PUBLIC               pcxEGA_10,pcxVGA_11,pcxVGA_12,pcxVGA_13,pcxHERC
pcxMINDISP           = 0
pcxCGA_4             = 0                    && CGA Mode  4H (320x200x4)
pcxCGA_6             = 1                    && CGA Mode  5H (640x200x2)
pcxEGA_D             = 2                    && EGA Mode  DH (320x200x16)
pcxEGA_E             = 3                    && EGA Mode  EH (640x200x16)
pcxEGA_F             = 4                    && EGA Mode  FH (640x350x2)
pcxEGA_10            = 5                    && EGA Mode 10H (640x350x16)
pcxVGA_11            = 6                    && VGA Mode 11H (640x480x2)
pcxVGA_12            = 7                    && VGA Mode 12H (640x480x16)
pcxVGA_13            = 8                    && VGA Mode 13H (320x200x256)
pcxHERC              = 9                    && Hercules     (720x348x2)

* New extended VGA modes
PUBLIC               pcxXGA_29,pcxXGA_2D,pcxXGA_2E,pcxXGA_30,pcxXGA_58
PUBLIC               pcxXGA_59,pcxXGA_5E,pcxXGA_5F
PUBLIC               pcxXGA_62,pcxXGA_66,pcxXGA_67,pcxXGA_69
pcxXGA_29            = 10                   && Tseng    29H (800x600x16)
pcxXGA_2D            = 11                   && Tseng    2DH (640x350x256)
pcxXGA_2E            = 12                   && Tseng    2EH (640x480x256)
pcxXGA_30            = 13                   && Tseng    30H (800x600x256)
pcxXGA_58            = 14                   && Paradise 58H (800x600x16)
pcxXGA_59            = 15                   && Paradise 59H (800x600x2)
pcxXGA_5E            = 16                   && Paradise 5EH (640x400x256)
pcxXGA_5F            = 17                   && Paradise 5FH (640x480x256)
pcxXGA_62            = 18                   && Video 7  62H (800x600x16)
pcxXGA_66            = 19                   && Video 7  66H (640x400x256)
pcxXGA_67            = 20                   && Video 7  67H (640x480x256)
pcxXGA_69            = 21                   && Video 7  69H (800x600x256)
pcxMAXDISP           = 21

* Printer Ports
PUBLIC               pcxLPT1,pcxLPT2,pcxLPT3
pcxLPT1              = 0                    && Printer port 1
pcxLPT2              = 1                    && Printer port 2
pcxLPT3              = 2                    && Printer port 3

* Printer Types
PUBLIC               pcxMINPRINT,pcxLASER,pcxDOTMAT,pcxMAXPRINT
pcxMINPRINT          = 0                    && Minimum printer type
pcxLASER             = 0                    && HP LaserJet
pcxDOTMAT            = 1                    && Dot Matrix
pcxMAXPRINT          = 1                    && Maximum printer type

* Printer Modes
PUBLIC               pcxDRAFT,pcxQUALITY
pcxDRAFT             = 0                    && Draft mode
pcxQUALITY           = 1                    && Quality

* Printer Scales
PUBLIC               pcxSCALE100,pcxSCALE75,pcxSCALE50,pcxSCALE25,pcxSCALE200
pcxSCALE100          = 0                    && 100%
pcxSCALE75           = 1                    &&  75%
pcxSCALE50           = 2                    &&  50%
pcxSCALE25           = 3                    &&  25%
pcxSCALE200          = 4                    && 200%

* Printer Flags
PUBLIC               pcxNORESET,pcxRESET,pcxNOEJECT,pcxEJECT
pcxNORESET           = 0                    && No reset before printing
pcxRESET             = 1                    && Reset before printing
pcxNOEJECT           = 0                    && No eject after printing
pcxEJECT             = 1                    && Eject page after printing

* Searches
PUBLIC               pcxFIRST,pcxNEXT
pcxFIRST             = 0                    && Find first matching entry
pcxNEXT              = 1                    && Find next matching entry

* Logical Operations
PUBLIC               pcxSET,pcxAND,pcxOR,pcxXOR
pcxSET               = 0                    && SET pixel value directly
pcxAND               = 1                    && AND pixel value with data
pcxOR                = 2                    && OR  pixel value with data
pcxXOR               = 3                    && XOR pixel value with data

* Virtual screens
PUBLIC               pcxEMM,pcxCMM
pcxEMM               = 0                    && Expanded Memory virtual
pcxCMM               = 1                    && Conventional Memory virtual

* Miscellaneous
PUBLIC               pcxTRUE,pcxFALSE,pcxSYNC
pcxTRUE              = 1                    && True value
pcxFALSE             = 0                    && False value
pcxSYNC              = 1                    && PCX library synch value

* Video Info Constants
PUBLIC               viNONE,viMDA,viCGA,viEGA,viMCGA,viVGA
PUBLIC               viHGC,viHGCPlus,viHGCColor
viNONE               = 0                    && No adapter/display
viMDA                = 1                    && Monochrome Display Adapter
viCGA                = 2                    && Color Graphics Adapter
viEGA                = 3                    && Enhanced Graphics Adapter
viMCGA               = 4                    && MCGA
viVGA                = 5                    && Video Graphics Array
viHGC                = 128                  && Hercules Monochrome
viHGCPlus            = 129                  && Hercules Plus
viHGCColor           = 130                  && Hercules InColor

PUBLIC               viMDAdisp,viCGAdisp,viEGAdisp,viVGAmono,viVGAcolor
viMDAdisp            = 1                    && Monochrome Display
viCGAdisp            = 2                    && CGA Display
viEGAdisp            = 3                    && EGA Display
viVGAmono            = 4                    && VGA Monochrome Display
viVGAcolor           = 5                    && VGA Color Display

* Chip sets
PUBLIC               chipUNKNOWN,chipTSENG,chipPARA,chipV7
chipUNKNOWN          = 0
chipTSENG            = 1
chipPARA             = 2
chipV7               = 3

* Hercules Configuration
PUBLIC               pcxHERCdiag,pcxHERChalf,pcxHERCfull
pcxHERCdiag          = 0                    && Hercules Diagnostic
pcxHERChalf          = 1                    && Hercules Half
pcxHERCfull          = 3                    && Hercules Full

* Error Codes
PUBLIC               pcxSUCCESS,pcxE_OPEN,pcxE_BUFSMALL,pcxE_READ,pcxE_WRITE
PUBLIC               pcxE_NOTPCX,pcxE_DISP,pcxE_MODE,pcxE_PAGE,pcxE_PAL
PUBLIC               pcxE_NOPAL,pcxE_NOGRABPAL,pcxE_NOTINLIB,pcxE_CLIPPARM
PUBLIC               pcxE_NOTIMPL,pcxE_GENERAL
pcxSUCCESS           = 0                    && Successful
pcxE_OPEN            = -1                   && Error opening file
pcxE_BUFSMALL        = -2                   && Buffer is too small
pcxE_READ            = -3                   && Error in reading from file
pcxE_WRITE           = -4                   && Error in writing to file
pcxE_NOTPCX          = -5                   && Not a valid pcx buffer/file
pcxE_DISP            = -6                   && Display not defined/invalid
pcxE_MODE            = -7                   && Bad display mode
pcxE_PAGE            = -8                   && Bad page
pcxE_PAL             = -9                   && Bad palette
pcxE_NOPAL           = -10                  && No palette available
pcxE_NOGRABPAL       = -11                  && Palette is not grabbed
pcxE_NOTLIB          = -12                  && Not a PCX library
pcxE_NOSYNC          = -13                  && Lost image synch in library
pcxE_NOTINLIB        = -14                  && Image not found in library
pcxE_CLIPPARM        = -15                  && Bad number of Clipper parms
pcxE_NOTIMPL         = -900                 && Not implemented yet
pcxE_GENERAL         = -999                 && General error

* New errors for version 3.5
PUBLIC               pcxE_BADPRINT,pcxE_BADPORT,pcxE_PRINTER,pcxE_NOTBW
PUBLIC               pcxE_ESCAPE,pcxE_NOEMM,pcxE_EMMFAIL,pcxE_EMMNOMEM
PUBLIC               pcxE_BADMTYPE,pcxE_CMMFAIL,pcxE_CMMNOMEM
pcxE_BADPRINT        = -16                  && Bad printer type
pcxE_BADPORT         = -17                  && Bad printer port
pcxE_PRINTER         = -18                  && Pr err (timeout,i/o,paper)
pcxE_NOTBW           = -19                  && Not a Black/White image
pcxE_ESCAPE          = -20                  && Escape key was pressed
pcxE_NOEMM           = -21                  && No EMM driver was found
pcxE_EMMFAIL         = -22                  && General EMM driver failure
pcxE_EMMNOMEM        = -23                  && No EMM memory available
pcxE_BADMTYPE        = -24                  && Bad virtual memory type
pcxE_CMMFAIL         = -25                  && General CMM alloc/free err
pcxE_CMMNOMEM        = -26                  && No CMM memory available

* PCX Structures (no equivalent structures for Clipper ...)

RETURN

* Functions
* EXTERNAL pcxFB
* EXTERNAL pcxBF
* EXTERNAL pcxSD
* EXTERNAL pcxGD
* EXTERNAL pcxSM
* EXTERNAL pcxSB
* EXTERNAL pcxBD
* EXTERNAL pcxDB
* EXTERNAL pcxLB
* EXTERNAL pcxFD
* EXTERNAL pcxDF
* EXTERNAL pcxLD
* EXTERNAL pcxSP
* EXTERNAL pcxGP
* EXTERNAL pcxVB
* EXTERNAL pcxGBH
* EXTERNAL pcxSBH
* EXTERNAL pcxGBT
* EXTERNAL pcxVF
* EXTERNAL pcxGFH
* EXTERNAL pcxSFH
* EXTERNAL pcxGFT
* EXTERNAL pcxGLH
* EXTERNAL pcxGLT
* EXTERNAL pcxDP
* EXTERNAL pcxEP
* EXTERNAL pcxSDP
* EXTERNAL pcxGDP
* EXTERNAL pcxSBP
* EXTERNAL pcxGBP
* EXTERNAL pcxSFP
* EXTERNAL pcxGFP
* EXTERNAL pcxGLP
* EXTERNAL pcxBPG
* EXTERNAL pcxEPG
* 
* New 3.5 Functions
* EXTERNAL pcxGV
* EXTERNAL pcxTB
* EXTERNAL pcxBT
* EXTERNAL pcxVI
* EXTERNAL pcxQC
* EXTERNAL pcxGDI
* EXTERNAL pcxSP
* EXTERNAL pcxBP
* EXTERNAL pcxFP
* EXTERNAL pcxLP
* EXTERNAL pcxEMI
* EXTERNAL pcxVS
* EXTERNAL pcxVF
* EXTERNAL pcxCV
* EXTERNAL pcxDV
* EXTERNAL pcxBV
* EXTERNAL pcxFV
* EXTERNAL pcxLV
* EXTERNAL pcxSH
* EXTERNAL pcxMC
* EXTERNAL pcxVD
* EXTERNAL pcxVS
* EXTERNAL pcxLS
* EXTERNAL pcxVP
* EXTERNAL pcxDP
* EXTERNAL pcxPI
* EXTERNAL pcxGI
 
