* pcxTest.PRG                                                               *
* Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved.  *

*****************************************************************************
*                                                                           *
* This program merely enters graphics mode, sets the palette, and displays  *
* the test image "pcxTest.PCX".  It is an example Clipper routine for the   *
* PCX Programmer's Toolkit.                                                 *
*                                                                           *
* NOTE: REQUIRES A CGA (or compatible) ADAPTER AND DISPLAY!                 *
*                                                                           *
* To Compile: Clipper pcxtest                                               *
*             Plink86 FI pcxtest LIB clipper,extend,pcx_clip,pcx_cl         *
*                                                                           *
* Nantucket Clipper                       Programmer: Chris Howard  2/01/89 *
*                                                                           *
*****************************************************************************


* Include the PCX Toolkit defines
SET PROCEDURE TO pcxlib
DO  pcxInit

PRIVATE  pcxpal,pcximage,pcxtype

* Globals
pcxpal   = SPACE(800)
pcximage = "pcxTest.PCX"
pcxtype  = pcxCGA_4

bufmax   = 20000
buffer   = SPACE(bufmax)

**********

* Main

  * Display program header
  ?
  ? "͸"
  ? " pcxTest: Example Clipper Test Program      PCX Programmer's Toolkit 3.50 "
  ? " Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved. "
  ? ";"
  ?

  * Get a key, to begin
  ? "Press a key to run . . ."
  INKEY(0)

  * Uncomment these lines to capture errors to a file
  * SET CONSOLE OFF
  * SET DEVICE TO PRINT
  * SET PRINT ON
  * SET PRINTER TO pcxtest.out

  * Allocate a larger toolkit buffer, to speed up file and display speed.
  * The toolkit defaults to using an internal 2KB buffer, but if we can  
  * spare more memory than that, declare a new buffer.                   
  * REMEMBER: This MUST be a GLOBAL buffer (ie, declare OUTSIDE of procs)

  retcode = pcxSB(buffer,bufmax);

  * Set the display type and mode we will be using
  retcode = pcxSD(pcxtype)
  IF (retcode = pcxSUCCESS)

    * Now enter graphics mode
    retcode = pcxSM(pcxGRAPHICS)
    IF (retcode = pcxSUCCESS)

      * We are in graphics mode, so set the image file palette
      * NOTE: If all your images use a default BIOS palette (or the      
      *       default Paintbrush palette), just SKIP setting the palette!

      retcode = pcxGFP(pcxtype,pcximage,pcxpal)
      IF (retcode = pcxSUCCESS)

        * Now set it
        retcode = pcxSDP(pcxpal)
        IF (retcode <> pcxSUCCESS)
          * Error setting palette
          ? "pcxSetDisplayPalette error:",retcode
        ENDIF

      ELSE
        * Error getting the palette
        ? "pcxGetFilePalette error:",retcode
      ENDIF

      * Now display the image file
      retcode = pcxFD(pcximage,0,0,0)
      IF (retcode <> pcxSUCCESS)
        * Error displaying the file
        ? "pcxFileDisplay error:",retcode
      ENDIF

      * Wait for a key
      INKEY(0)

      * Return to text mode
      pcxSM(pcxTEXT)

    ELSE
      * Error setting the mode
      ? "pcxSetMode error:",retcode
    ENDIF

  ELSE
    * Error setting the display type
    ? "pcxSetDisplay error:",retcode
  ENDIF

RETURN && Main

